--[[
Author: Mantrid
https://fs.mantrid.net/
Copyright: All rights reserved
LEGAL NOTICE: This mod, and this file in particular, are only authorised for distribution by GIANTS Software. All other entities agree to pay the sum of AU$1,000,000 for distribution rights.
Aspiring developers: I have limited experience with coding LUA, so my methods may not be the best. You're welcome to read and play with the code, for the purposes of learning, but do not copy whole functions for your own projects.
Experienced developers: It's my first day :)
]]

proShot = {}

function initMod()
	proShot.isActive = false
	proShot.isSet = false
	proShot.invertRotY = false
	proShot.reEnableHUD = false
	proShot.previousCamera = 0
	proShot.captureCoolDown = 0
	proShot.F1throttle = 0
	proShot.vehicleReloadThrottle = 0
	proShot.placeableReloadThrottle = 0
	proShot.modDir = g_currentModDirectory

	proShot.mouseButtonDown = {}
	proShot.fromWhenceYouCame = {}
	proShot.buttonId = {}
	proShot.inputGlyphs = {}
	proShot.keyLockout = {}
	proShot.menuRebuilding = false

	proShot.lightI3D = g_currentModDirectory .. "lights.i3d"
	proShot.cameraSound = createSample("cameraSound")
	loadSample(proShot.cameraSound, g_currentModDirectory .. "cameraSound.ogg", false)

	-- Override some base-game functions
	GamePausedDisplay.draw = Utils.overwrittenFunction(GamePausedDisplay.draw, proShot.insteadof_GamePausedDisplay_draw)
	GamePausedDisplay.createBackground = Utils.overwrittenFunction(GamePausedDisplay.createBackground, proShot.insteadof_GamePausedDisplay_createBackground)
	
	proShot.dynamicMenuNames = {
		["spring"] = g_i18n:getText("proShot_spring") .. " (" .. g_i18n:getText("proShot_early") .. ")",
		["summer"] = g_i18n:getText("proShot_summer") .. " (" .. g_i18n:getText("proShot_early") .. ")",
		["autumn"] = g_i18n:getText("proShot_autumn") .. " (" .. g_i18n:getText("proShot_early") .. ")",
		["winter"] = g_i18n:getText("proShot_winter") .. " (" .. g_i18n:getText("proShot_early") .. ")",
		["sunny"] = g_i18n:getText("proShot_weather_SUN") .. " (1)",
		["cloudy"] = g_i18n:getText("proShot_weather_CLOUDY") .. " (1)",
		["rainy"] = g_i18n:getText("proShot_weather_RAIN") .. " (1)",
		["snowy"] = g_i18n:getText("proShot_weather_SNOW") .. " (1)"
	}

	proShot.menus = {
		["main"] = {
			-- InputAction, callback, Text, Prio
			{ "PRO_SHOT_1", "callbackMenu_main", g_i18n:getText("proShot_menu_qualLow"), 3 },
			{ "PRO_SHOT_2", "callbackMenu_main", g_i18n:getText("proShot_menu_qualHigh"), 3 },
			{ "PRO_SHOT_DIVMUL", "callbackMenu_main", g_i18n:getText("proShot_menu_light_temp"), 3 },
			{ "PRO_SHOT_KP_MINUSPLUS", "callbackMenu_main", g_i18n:getText("proShot_menu_sun_intensity"), 3 },
			{ "PRO_SHOT_MINUSEQUALS", "callbackMenu_main", g_i18n:getText("proShot_menu_exposure"), 3 },
			{ "PRO_SHOT_SQUAREBRACKETS", "callbackMenu_main", g_i18n:getText("proShot_menu_FoV"), 3 },
			{ "PRO_SHOT_0", "callbackMenu_main", g_i18n:getText("proShot_menu_advMenus"), 4 },
			{ "PRO_SHOT_F", "callbackMenu_main", g_i18n:getText("proShot_menu_flashLightToggle"), 4 },
			{ "PRO_SHOT_F1", "callbackMenu_void", g_i18n:getText("proShot_hideHUD"), 4 },
			{ "PRO_SHOT_ENTER", "callbackMenu_void", g_i18n:getText("proShot_takePicture"), 4 }
		},
		["advMenu"] = {
			{ "PRO_SHOT_1", "callbackMenu_advMenu", g_i18n:getText("proShot_menu_environment"), 4 },
			{ "PRO_SHOT_2", "callbackMenu_advMenu", g_i18n:getText("proShot_menu_effects"), 4 },
			{ "PRO_SHOT_3", "callbackMenu_advMenu", g_i18n:getText("proShot_menu_advSunMenu"), 4 },
			{ "PRO_SHOT_4", "callbackMenu_advMenu", g_i18n:getText("proShot_menu_advLightMenu"), 4 },
			{ "PRO_SHOT_5", "callbackMenu_advMenu", g_i18n:getText("proShot_menu_DoF"), 4 },
			{ "PRO_SHOT_6", "callbackMenu_advMenu", g_i18n:getText("proShot_menu_advQualityMenu"), 4 },
			{ "PRO_SHOT_F", "callbackMenu_main", g_i18n:getText("proShot_menu_flashLightToggle"), 4 },
			{ "PRO_SHOT_BACKSPACE", "callbackMenu_main", g_i18n:getText("proShot_menu_returnToMain"), 4 },
			{ "PRO_SHOT_F1", "callbackMenu_void", g_i18n:getText("proShot_hideHUD"), 4 },
			{ "PRO_SHOT_ENTER", "callbackMenu_void", g_i18n:getText("proShot_takePicture"), 4 }
		},
		["environment"] = {
			{ "PRO_SHOT_1", "callbackMenu_enviro", {"spring"}, 3 },
			{ "PRO_SHOT_2", "callbackMenu_enviro", {"summer"}, 3 },
			{ "PRO_SHOT_3", "callbackMenu_enviro", {"autumn"}, 3 },
			{ "PRO_SHOT_4", "callbackMenu_enviro", {"winter"}, 3 },
			{ "PRO_SHOT_5", "callbackMenu_enviro", {"sunny"}, 3 },
			{ "PRO_SHOT_6", "callbackMenu_enviro", {"cloudy"}, 3 },
			{ "PRO_SHOT_7", "callbackMenu_enviro", {"rainy"}, 3 },
			{ "PRO_SHOT_8", "callbackMenu_enviro", {"snowy"}, 3 },
			{ "PRO_SHOT_DOT3", "callbackMenu_enviro", g_i18n:getText("proShot_seasonTweak"), 3 },
			{ "PRO_SHOT_DIVMUL", "callbackMenu_enviro", g_i18n:getText("proShot_menu_timeHorly"), 3 },
			{ "PRO_SHOT_KP_MINUSPLUS", "callbackMenu_enviro", g_i18n:getText("proShot_menu_timeMins"), 3 },
			{ "PRO_SHOT_MINUSEQUALS", "callbackMenu_enviro", g_i18n:getText("proShot_menu_snowShader"), 3 },
			{ "PRO_SHOT_SQUAREBRACKETS", "callbackMenu_enviro", g_i18n:getText("proShot_infoBox_snowLevel"), 3 },

			{ "PRO_SHOT_BACKSLASH", "callbackMenu_enviro", g_i18n:getText("proShot_menu_resetThis"), 1 },
			{ "PRO_SHOT_BACKSPACE", "callbackMenu_main", g_i18n:getText("proShot_menu_returnToMain"), 4 },
			{ "PRO_SHOT_F1", "callbackMenu_void", g_i18n:getText("proShot_hideHUD"), 4 },
			{ "PRO_SHOT_ENTER", "callbackMenu_void", g_i18n:getText("proShot_takePicture"), 4 }
		},
		["DoF"] = {
			{ "PRO_SHOT_1", "callbackMenu_DoF", g_i18n:getText("proShot_menu_DoF_preset") .. " 1", 3 },
			{ "PRO_SHOT_2", "callbackMenu_DoF", g_i18n:getText("proShot_menu_DoF_preset") .. " 2", 3 },
			{ "PRO_SHOT_3", "callbackMenu_DoF", g_i18n:getText("proShot_menu_DoF_preset") .. " 3", 3 },
			{ "PRO_SHOT_4", "callbackMenu_DoF", g_i18n:getText("proShot_menu_DoF_preset") .. " 4", 3 },
			{ "PRO_SHOT_5", "callbackMenu_DoF", g_i18n:getText("proShot_menu_DoF_preset") .. " 5", 3 },
			{ "PRO_SHOT_DIVMUL", "callbackMenu_DoF", g_i18n:getText("proShot_menu_DoF_nearBlurAmount"), 3 },
			{ "PRO_SHOT_KP_MINUSPLUS", "callbackMenu_DoF", g_i18n:getText("proShot_menu_DoF_farBlurAmount"), 3 },
			{ "PRO_SHOT_47", "callbackMenu_DoF", g_i18n:getText("proShot_menu_DoF_nearBlurEnd"), 3 },
			{ "PRO_SHOT_58", "callbackMenu_DoF", g_i18n:getText("proShot_menu_DoF_farBlurStart"), 3 },
			{ "PRO_SHOT_69", "callbackMenu_DoF", g_i18n:getText("proShot_menu_DoF_farBlurEnd"), 3 },
			{ "PRO_SHOT_KP_0", "callbackMenu_DoF", g_i18n:getText("proShot_DoF_applyToSky"), 3 },
			{ "PRO_SHOT_BACKSLASH", "callbackMenu_DoF", g_i18n:getText("proShot_menu_resetThis"), 3 },
			{ "PRO_SHOT_BACKSPACE", "callbackMenu_main", g_i18n:getText("proShot_menu_returnToMain"), 4 },

			{ "PRO_SHOT_F1", "callbackMenu_void", g_i18n:getText("proShot_hideHUD"), 4 },
			{ "PRO_SHOT_ENTER", "callbackMenu_void", g_i18n:getText("proShot_takePicture"), 4 }
		},
		["effects"] = {
			{ "PRO_SHOT_1", "callbackMenu_effects", g_i18n:getText("proShot_menu_effects_preset_flat"), 2 },
			{ "PRO_SHOT_2", "callbackMenu_effects", g_i18n:getText("proShot_menu_effects_preset_vibrant"), 2 },
			{ "PRO_SHOT_3", "callbackMenu_effects", g_i18n:getText("proShot_menu_effects_preset_deep"), 2 },
			{ "PRO_SHOT_4", "callbackMenu_effects", g_i18n:getText("proShot_menu_effects_preset_cold"), 2 },
			{ "PRO_SHOT_5", "callbackMenu_effects", g_i18n:getText("proShot_menu_effects_preset_greyscale"), 2 },
			{ "PRO_SHOT_6", "callbackMenu_effects", g_i18n:getText("proShot_menu_effects_preset_sepiaTone"), 2 },
			{ "PRO_SHOT_7", "callbackMenu_effects", g_i18n:getText("proShot_menu_effects_preset_phantom"), 2 },
			{ "PRO_SHOT_47", "callbackMenu_effects", g_i18n:getText("proShot_menu_effects_bloomThreshold"), 2 },
			{ "PRO_SHOT_58", "callbackMenu_effects", g_i18n:getText("proShot_menu_effects_bloomMagnitude"), 2 },
			{ "PRO_SHOT_69", "callbackMenu_effects", g_i18n:getText("proShot_menu_effects_bloomQuality"), 2 },
			{ "PRO_SHOT_KP_MINUSPLUS", "callbackMenu_effects", g_i18n:getText("proShot_menu_effects_SSAOIntensity"), 2 },
			{ "PRO_SHOT_BACKSLASH", "callbackMenu_effects", g_i18n:getText("proShot_menu_resetThis"), 3 },
			{ "PRO_SHOT_BACKSPACE", "callbackMenu_main", g_i18n:getText("proShot_menu_returnToMain"), 4 },

			{ "PRO_SHOT_F1", "callbackMenu_void", g_i18n:getText("proShot_hideHUD"), 4 },
			{ "PRO_SHOT_ENTER", "callbackMenu_void", g_i18n:getText("proShot_takePicture"), 4 }
		},
		["advQuality"] = {
			{ "PRO_SHOT_47", "callbackMenu_advQuality", g_i18n:getText("proShot_menu_advQ_VD"), 4 },
			{ "PRO_SHOT_58", "callbackMenu_advQuality", g_i18n:getText("proShot_menu_advQ_LOD"), 4 },
			{ "PRO_SHOT_69", "callbackMenu_advQuality", g_i18n:getText("proShot_menu_advQ_TLOD"), 4 },
			{ "PRO_SHOT_KP_MINUSPLUS", "callbackMenu_advQuality", g_i18n:getText("proShot_menu_advQ_FVD"), 4 },
			{ "PRO_SHOT_BACKSPACE", "callbackMenu_main", g_i18n:getText("proShot_menu_returnToMain"), 4 },
			{ "PRO_SHOT_F1", "callbackMenu_void", g_i18n:getText("proShot_hideHUD"), 4 },
			{ "PRO_SHOT_ENTER", "callbackMenu_void", g_i18n:getText("proShot_takePicture"), 4 }
		},
		["sun"] = {
			{ "PRO_SHOT_DIVMUL", "callbackMenu_sun", g_i18n:getText("proShot_menu_light_temp"), 1 },
			{ "PRO_SHOT_47", "callbackMenu_sun", g_i18n:getText("proShot_menu_red"), 2 },
			{ "PRO_SHOT_58", "callbackMenu_sun", g_i18n:getText("proShot_menu_green"), 2 },
			{ "PRO_SHOT_69", "callbackMenu_sun", g_i18n:getText("proShot_menu_blue"), 2 },
			{ "PRO_SHOT_SQUAREBRACKETS", "callbackMenu_sun", g_i18n:getText("proShot_menu_sunSize"), 2 },
			{ "PRO_SHOT_MINUSEQUALS", "callbackMenu_sun", g_i18n:getText("proShot_menu_atmosRefraction"), 3 },
			{ "PRO_SHOT_KP_MINUSPLUS", "callbackMenu_sun", g_i18n:getText("proShot_menu_sun_intensity"), 3 },
			{ "PRO_SHOT_DOT3", "callbackMenu_sun", g_i18n:getText("proShot_menu_moonSize"), 4 },

			{ "PRO_SHOT_BACKSLASH", "callbackMenu_sun", g_i18n:getText("proShot_menu_resetThis"), 4 },
			{ "PRO_SHOT_BACKSPACE", "callbackMenu_main", g_i18n:getText("proShot_menu_returnToMain"), 4 },
			{ "PRO_SHOT_F1", "callbackMenu_void", g_i18n:getText("proShot_hideHUD"), 4 },
			{ "PRO_SHOT_ENTER", "callbackMenu_void", g_i18n:getText("proShot_takePicture"), 4 }
		},
		["flashLight"] = {
			{ "PRO_SHOT_47", "callbackMenu_flashLight", g_i18n:getText("proShot_menu_red"), 1 },
			{ "PRO_SHOT_58", "callbackMenu_flashLight", g_i18n:getText("proShot_menu_green"), 1 },
			{ "PRO_SHOT_69", "callbackMenu_flashLight", g_i18n:getText("proShot_menu_blue"), 1 },
			{ "PRO_SHOT_DIVMUL", "callbackMenu_flashLight", g_i18n:getText("proShot_menu_light_temp"), 1 },
			{ "PRO_SHOT_KP_MINUSPLUS", "callbackMenu_flashLight", g_i18n:getText("proShot_menu_flashLight_intensity"), 1 },
			{ "PRO_SHOT_SQUAREBRACKETS", "callbackMenu_flashLight", g_i18n:getText("proShot_menu_flashLight_distance"), 1 },
			{ "PRO_SHOT_DOT3", "callbackMenu_flashLight", g_i18n:getText("proShot_menu_flashLight_coneAngle"), 1 },
			{ "PRO_SHOT_MINUSEQUALS", "callbackMenu_flashLight", g_i18n:getText("proShot_menu_flashLight_dropOff"), 1 },
			{ "PRO_SHOT_BACKSPACE", "callbackMenu_main", g_i18n:getText("proShot_menu_returnToMain"), 4 },
			{ "PRO_SHOT_KP_ENTER", "callbackMenu_flashLight", g_i18n:getText("proShot_menu_flashLight_place"), 4 },
			{ "PRO_SHOT_BACKSLASH", "callbackMenu_flashLight", g_i18n:getText("proShot_menu_flashLight_removeLast"), 4 },
			{ "PRO_SHOT_F", "callbackMenu_main", g_i18n:getText("proShot_menu_flashLightToggle"), 4 },
			{ "PRO_SHOT_F1", "callbackMenu_void", g_i18n:getText("proShot_hideHUD"), 4 },

			{ "PRO_SHOT_ENTER", "callbackMenu_void", g_i18n:getText("proShot_takePicture"), 4 }
		}
	}

end

function proShot:callbackMenu_flashLight(what, axisComponent)
	if proShot:keyRepeatThrottle(false, what, axisComponent, 30) then
		local light = proShot.heldLight
		local r, g, b = getLightColor(light.lightNode)

		if what == "PRO_SHOT_47" and axisComponent == -1 then
			proShot:lightColourChange({-0.1, 0, 0}, light)
		elseif what == "PRO_SHOT_47" and axisComponent == 1 then
			proShot:lightColourChange({0.1, 0, 0}, light)
		elseif what == "PRO_SHOT_58" and axisComponent == -1 then
			proShot:lightColourChange({0, -0.1, 0}, light)
		elseif what == "PRO_SHOT_58" and axisComponent == 1 then
			proShot:lightColourChange({0, 0.1, 0}, light)
		elseif what == "PRO_SHOT_69" and axisComponent == -1 then
			proShot:lightColourChange({0, 0, -0.1}, light)
		elseif what == "PRO_SHOT_69" and axisComponent == 1 then
			proShot:lightColourChange({0, 0, 0.1}, light)
		elseif what == "PRO_SHOT_DIVMUL" and axisComponent == -1 then
			light.colourTemp = math.min(math.floor(light.colourTemp + light.colourTemp / 10), 40000)
			setLightColor(light.lightNode, self:colourTempToRGB(light.colourTemp, light.intensity))
			light.colourTempIsPreset = true
		elseif what == "PRO_SHOT_DIVMUL"  and axisComponent == 1 then
			light.colourTemp = math.max(math.floor(light.colourTemp - light.colourTemp / 10), 1000)
			setLightColor(light.lightNode, self:colourTempToRGB(light.colourTemp, light.intensity))
			light.colourTempIsPreset = true
		elseif what == "PRO_SHOT_KP_MINUSPLUS" and axisComponent == -1 then
			proShot:lightIntensityChange(-0.1, light)
		elseif what == "PRO_SHOT_KP_MINUSPLUS"	and axisComponent == 1 then
			proShot:lightIntensityChange(0.1, light)
		elseif what == "PRO_SHOT_DOT3" and axisComponent == -1 then
			proShot:lightFauxSet(light.coneAngle - 10, light.dropOff)
		elseif what == "PRO_SHOT_DOT3"	and axisComponent == 1 then
			proShot:lightFauxSet(light.coneAngle + 10, light.dropOff)
		elseif what == "PRO_SHOT_MINUSEQUALS" and axisComponent == -1 then
			proShot:lightFauxSet(light.coneAngle, light.dropOff - 1)
		elseif what == "PRO_SHOT_MINUSEQUALS"  and axisComponent == 1 then
			proShot:lightFauxSet(light.coneAngle, light.dropOff + 1)
		elseif what == "PRO_SHOT_SQUAREBRACKETS" and axisComponent == -1 then
			light.range = math.max(getLightRange(light.lightNode) - 1, 0)
			setLightRange(light.lightNode, light.range)
		elseif what == "PRO_SHOT_SQUAREBRACKETS"  and axisComponent == 1 then
			light.range = math.min(getLightRange(light.lightNode) + 1, 500)
			setLightRange(light.lightNode, light.range)
		elseif what == "PRO_SHOT_KP_ENTER" then
			proShot:lightPlace(light)
		elseif what == "PRO_SHOT_BACKSLASH" then
			local lightToRemove = 0
			local indexToRemove = 0
			for k, lightId in ipairs(proShot.placedLights) do
				lightToRemove = lightId
				indexToRemove = k
			end
			if lightToRemove ~= 0 then
				unlink(lightToRemove)
				proShot.placedLights[indexToRemove] = nil
			end
		else
			Logging.info("Unknown menuCallback: " .. tostring(what))
		end
	end
end

function proShot:callbackMenu_main(what, axisComponent)
	if proShot:keyRepeatThrottle(false, what, axisComponent, 30) then
		if what == "PRO_SHOT_1" then -- Set Low Quality
			setViewDistanceCoeff(1)
			setLODDistanceCoeff(1)
			setTerrainLODDistanceCoeff(1)
			setFoliageViewDistanceCoeff(1)
		elseif what == "PRO_SHOT_2" then -- Set High Quality
			setViewDistanceCoeff(10)
			setLODDistanceCoeff(10)
			setTerrainLODDistanceCoeff(10)
			setFoliageViewDistanceCoeff(5)
		elseif what == "PRO_SHOT_DIVMUL" and axisComponent == -1 then -- Lower Sun Temp
			proShot.sun.colourTemp = math.min(math.floor(proShot.sun.colourTemp + proShot.sun.colourTemp / 10), 40000)
			setLightColor(proShot.sun.lightNode, self:colourTempToRGB(proShot.sun.colourTemp, proShot.sun.intensity))
			proShot.sun.colourTempIsPreset = true
		elseif what == "PRO_SHOT_DIVMUL" and axisComponent == 1 then -- Raise Sun Temp
			proShot.sun.colourTemp = math.max(math.floor(proShot.sun.colourTemp - proShot.sun.colourTemp / 10), 1000)
			setLightColor(proShot.sun.lightNode, self:colourTempToRGB(proShot.sun.colourTemp, proShot.sun.intensity))
			proShot.sun.colourTempIsPreset = true
		elseif what == "PRO_SHOT_MINUSEQUALS" and axisComponent == -1 then -- Lower Exposure
			proShot.exposureMinValue = math.max(proShot.exposureMinValue - 0.1, -5)
			setExposureRange(proShot.exposureKeyValue, proShot.exposureMinValue, proShot.exposureMinValue)
		elseif what == "PRO_SHOT_MINUSEQUALS" and axisComponent == 1 then -- Raise Exposure
			proShot.exposureMinValue = math.min(proShot.exposureMinValue + 0.1, 5)
			setExposureRange(proShot.exposureKeyValue, proShot.exposureMinValue, proShot.exposureMinValue)
		elseif what == "PRO_SHOT_SQUAREBRACKETS" and axisComponent == -1 then -- Lower FoV
			proShot.FoV = math.max(proShot.FoV - 1, 1)
			setFovY(getChildAt(proShot.tripod, 0), math.rad(proShot.FoV))
		elseif what == "PRO_SHOT_SQUAREBRACKETS" and axisComponent == 1 then -- Raise FoV
			proShot.FoV = math.min(proShot.FoV + 1, 170)
			setFovY(getChildAt(proShot.tripod, 0), math.rad(proShot.FoV))
		elseif what == "PRO_SHOT_KP_MINUSPLUS" and axisComponent == -1 then -- Lower Sun Intensity
			proShot:lightIntensityChange(-0.1, proShot.sun)
		elseif what == "PRO_SHOT_KP_MINUSPLUS" and axisComponent == 1 then -- Raise Sun Intensity
			proShot:lightIntensityChange(0.1, proShot.sun)
		elseif what == "PRO_SHOT_F" then -- Toggle flashlight
			self:toggleFlashLight()
		elseif what == "PRO_SHOT_0" then
			proShot.menuDesired = "advMenu"
		elseif what == "PRO_SHOT_BACKSPACE" then
			proShot.menuDesired = "main"
		else
			Logging.info("Unknown menuCallback: " .. tostring(what))
		end
	end
end

function proShot:callbackMenu_advMenu(what, axisComponent)
	if proShot:keyRepeatThrottle(false, what, axisComponent, 40) then
		if what == "PRO_SHOT_1" then -- Environment menu
			proShot.menuDesired = "environment"
		elseif what == "PRO_SHOT_2" then -- Effects menu
			proShot.menuDesired = "effects"
		elseif what == "PRO_SHOT_3" then -- Advanced Sun menu
			proShot.menuDesired = "sun"
		elseif what == "PRO_SHOT_4" then -- Advanced lighting menu
			proShot.menuDesired = "flashLight"
		elseif what == "PRO_SHOT_5" then -- DoF menu
			proShot.menuDesired = "DoF"
		elseif what == "PRO_SHOT_6" then -- Advanced Quality menu
			proShot.menuDesired = "advQuality"
		elseif what == "PRO_SHOT_BACKSPACE" then
			proShot.menuDesired = "main"
		else
			Logging.info("Unknown menuCallback: " .. tostring(what))
		end
	end
end

function proShot:callbackMenu_enviro(what, axisComponent)
	if proShot:keyRepeatThrottle(false, what, axisComponent, 40) then
		if what == "PRO_SHOT_1" then
			proShot:seasonChange("spring")
		elseif what == "PRO_SHOT_2" then
			proShot:seasonChange("summer")
		elseif what == "PRO_SHOT_3" then
			proShot:seasonChange("autumn")
		elseif what == "PRO_SHOT_4" then
			proShot:seasonChange("winter")
		elseif what == "PRO_SHOT_5" then
			proShot:weatherChange("SUN")
		elseif what == "PRO_SHOT_6" then
			proShot:weatherChange("CLOUDY")
		elseif what == "PRO_SHOT_7" then
			proShot:weatherChange("RAIN")
		elseif what == "PRO_SHOT_8" then
			proShot:weatherChange("SNOW")

		elseif what == "PRO_SHOT_DIVMUL" and axisComponent == 1 then
			-- Jump time by hour
			proShot:timeChange(g_currentMission.environment.dayTime + 3600000)
		elseif what == "PRO_SHOT_DIVMUL" and axisComponent == -1 then
			proShot:timeChange(g_currentMission.environment.dayTime - 3600000)
		elseif what == "PRO_SHOT_KP_MINUSPLUS" and axisComponent == 1 then
			-- Jump time by minute
			proShot:timeChange(g_currentMission.environment.dayTime + 60000)
		elseif what == "PRO_SHOT_KP_MINUSPLUS" and axisComponent == -1 then
			-- Jump time by minute
			proShot:timeChange(g_currentMission.environment.dayTime - 60000)
		elseif what == "PRO_SHOT_MINUSEQUALS" and axisComponent == 1 then
			-- Increase snow shader
			g_currentMission.snowSystem.snowShaderValue = math.min(g_currentMission.snowSystem.snowShaderValue + 0.1, 1)
			setSharedShaderParameter(Shader.PARAM_SHARED_SNOW, g_currentMission.snowSystem.snowShaderValue)
		elseif what == "PRO_SHOT_MINUSEQUALS" and axisComponent == -1 then
			g_currentMission.snowSystem.snowShaderValue = math.max(g_currentMission.snowSystem.snowShaderValue - 0.1, 0)
			setSharedShaderParameter(Shader.PARAM_SHARED_SNOW, g_currentMission.snowSystem.snowShaderValue)
		elseif what == "PRO_SHOT_SQUAREBRACKETS" and axisComponent == 1 then
			-- Increase snow level
			proShot:snowBusiness(proShot:snowBusiness("getHeight") + 0.1)
		elseif what == "PRO_SHOT_SQUAREBRACKETS" and axisComponent == -1 then
			proShot:snowBusiness(proShot:snowBusiness("getHeight") - 0.1)
		elseif what == "PRO_SHOT_DOT3" and axisComponent == 1 then
			proShot:seasonChange("tweakUp")
		elseif what == "PRO_SHOT_DOT3" and axisComponent == -1 then
			proShot:seasonChange("tweakDown")
		elseif what == "PRO_SHOT_BACKSLASH" and axisComponent == 1 then
			local fwyc = proShot.fromWhenceYouCame
			g_currentMission.environment:loadFromXMLFile(fwyc.environment, "environment")
			g_currentMission.snowSystem.snowShaderValue = fwyc.snowShaderValue
			setSharedShaderParameter(Shader.PARAM_SHARED_SNOW, fwyc.snowShaderValue)
			proShot:snowBusiness(fwyc.snowLevel)
			g_currentMission.environment.currentVisualPeriod = fwyc.currentVisualPeriod
			g_currentMission.environment.visualPeriodLocked = fwyc.visualPeriodLocked
			g_currentMission.environment:update(g_currentDt)
		else
			Logging.info("Unknown menuCallback: " .. tostring(what))
		end
	end
end

function proShot:callbackMenu_DoF(what, axisComponent)
	if proShot:keyRepeatThrottle(false, what, axisComponent, 30) then
		local nearCoCRadius, nearBlurEnd, farCoCRadius, farBlurStart, farBlurEnd, applyToSky = unpack(g_depthOfFieldManager.currentState)

		if what == "PRO_SHOT_1" and axisComponent == 1 then
			-- Preset
			nearCoCRadius, nearBlurEnd, farCoCRadius, farBlurStart, farBlurEnd, applyToSky = 3, 3, 20, 2, 2500, true
		elseif what == "PRO_SHOT_2" and axisComponent == 1 then
			-- Preset
			nearCoCRadius, nearBlurEnd, farCoCRadius, farBlurStart, farBlurEnd, applyToSky = 2.5, 5, 14, 9, 2500, true
		elseif what == "PRO_SHOT_3" and axisComponent == 1 then
			-- Preset
			nearCoCRadius, nearBlurEnd, farCoCRadius, farBlurStart, farBlurEnd, applyToSky = 1, 10, 22, 20, 2500, false
		elseif what == "PRO_SHOT_4" and axisComponent == 1 then
			-- Preset
			nearCoCRadius, nearBlurEnd, farCoCRadius, farBlurStart, farBlurEnd, applyToSky = 4, 11, 6, 10, 2500, false
		elseif what == "PRO_SHOT_5" and axisComponent == 1 then
			-- Preset
			nearCoCRadius, nearBlurEnd, farCoCRadius, farBlurStart, farBlurEnd, applyToSky = 10, 0.1, 9, 1, 2500, false
		elseif what == "PRO_SHOT_47" and axisComponent == 1 then
			nearBlurEnd = math.min(nearBlurEnd + 0.1, 99)
		elseif what == "PRO_SHOT_47" and axisComponent == -1 then
			nearBlurEnd = math.max(nearBlurEnd - 0.1, 0.1)
		elseif what == "PRO_SHOT_58" and axisComponent == 1 then
			farBlurStart = math.ceil(math.min(farBlurStart + MathUtil.clamp(farBlurStart / 100, 1, 50), 2000))
				if farBlurStart + 1 > farBlurEnd then
					farBlurStart = farBlurEnd - 1
				end
		elseif what == "PRO_SHOT_58" and axisComponent == -1 then
			farBlurStart = math.floor(math.max(farBlurStart - MathUtil.clamp(farBlurStart / 100, 1, 50), 1))
		elseif what == "PRO_SHOT_69" and axisComponent == 1 then
			farBlurEnd = math.ceil(math.min(farBlurEnd + MathUtil.clamp(farBlurEnd / 100, 1, 50), 2500))
		elseif what == "PRO_SHOT_69" and axisComponent == -1 then
			farBlurEnd = math.floor(math.max(farBlurEnd - MathUtil.clamp(farBlurEnd / 100, 1, 50), 2))
				if farBlurEnd < farBlurStart + 1 then
					farBlurEnd = farBlurStart + 1
				end
		elseif what == "PRO_SHOT_KP_MINUSPLUS" and axisComponent == 1 then
			farCoCRadius = math.min(farCoCRadius + 0.1, 20)
		elseif what == "PRO_SHOT_KP_MINUSPLUS" and axisComponent == -1 then
			farCoCRadius = math.max(farCoCRadius - 0.1, 0.1)
		elseif what == "PRO_SHOT_DIVMUL" and axisComponent == 1 then
			nearCoCRadius = math.min(nearCoCRadius + 0.1, 10)
		elseif what == "PRO_SHOT_DIVMUL" and axisComponent == -1 then
			nearCoCRadius = math.max(nearCoCRadius - 0.1, 0.1)
		elseif what == "PRO_SHOT_BACKSLASH" and axisComponent == 1 then
			nearCoCRadius, nearBlurEnd, farCoCRadius, farBlurStart, farBlurEnd, applyToSky = unpack(proShot.fromWhenceYouCame.DoF)
		elseif what == "PRO_SHOT_KP_0" and axisComponent == 1 then
			applyToSky =  not applyToSky
		else
			Logging.info("Unknown menuCallback: " .. tostring(what))
		end
		
		setDoFparams(nearCoCRadius, nearBlurEnd, farCoCRadius, farBlurStart, farBlurEnd, applyToSky)
	end
end

function proShot:callbackMenu_effects(what, axisComponent)
	if proShot:keyRepeatThrottle(false, what, axisComponent, 30) then
		if what == "PRO_SHOT_1" and axisComponent == 1 then
			proShot:colorGradingSet(1)
		elseif what == "PRO_SHOT_2" and axisComponent == 1 then
			proShot:colorGradingSet(2)
		elseif what == "PRO_SHOT_3" and axisComponent == 1 then
			proShot:colorGradingSet(3)
		elseif what == "PRO_SHOT_4" and axisComponent == 1 then
			proShot:colorGradingSet(4)
		elseif what == "PRO_SHOT_5" and axisComponent == 1 then
			proShot:colorGradingSet(5)
		elseif what == "PRO_SHOT_6" and axisComponent == 1 then
			proShot:colorGradingSet(6)
		elseif what == "PRO_SHOT_7" and axisComponent == 1 then
			proShot:colorGradingSet(7)
		elseif what == "PRO_SHOT_47" and axisComponent == 1 then
			setBloomMaskThreshold(math.min(getBloomMaskThreshold() + 0.1, 50))
		elseif what == "PRO_SHOT_47" and axisComponent == -1 then
			setBloomMaskThreshold(math.max(getBloomMaskThreshold() - 0.1, 0.1))
		elseif what == "PRO_SHOT_58" and axisComponent == 1 then
			setBloomMagnitude(math.min(getBloomMagnitude() + MathUtil.clamp(getBloomMagnitude() / 100, 0.1, 10), 900))
		elseif what == "PRO_SHOT_58" and axisComponent == -1 then
			setBloomMagnitude(math.max(getBloomMagnitude() - MathUtil.clamp(getBloomMagnitude() / 100, 0.1, 10), 0.1))
		elseif what == "PRO_SHOT_69" and axisComponent == 1 then
			setBloomQuality(math.min(getBloomQuality() + 1, 5))
		elseif what == "PRO_SHOT_69" and axisComponent == -1 then
			setBloomQuality(getBloomQuality() - 0.1)

		elseif what == "PRO_SHOT_KP_MINUSPLUS" and axisComponent == 1 then
			setSSAOIntensity(math.min(getSSAOIntensity() + 0.1, 20))
		elseif what == "PRO_SHOT_KP_MINUSPLUS" and axisComponent == -1 then
			setSSAOIntensity(math.max(getSSAOIntensity() - 0.1, 0))

		elseif what == "PRO_SHOT_BACKSLASH" and axisComponent == 1 then
			proShot:colorGradingSet()
			local fwyc = proShot.fromWhenceYouCame
			setBloomMagnitude(fwyc.bloom[1])
			setBloomMaskThreshold(fwyc.bloom[2])
			setBloomQuality(fwyc.bloom[3])
			setSSAOIntensity(fwyc.SSAOIntensity)
		else
			Logging.info("Unknown menuCallback: " .. tostring(what))
		end
	end
end

function proShot:callbackMenu_advQuality(what, axisComponent)
	if proShot:keyRepeatThrottle(false, what, axisComponent, 30) then
		if what == "PRO_SHOT_47" and axisComponent == -1 then
			setViewDistanceCoeff(math.max(getViewDistanceCoeff() - 1, 1e-06))
		elseif what == "PRO_SHOT_47" and axisComponent == 1 then
			setViewDistanceCoeff(math.min(getViewDistanceCoeff() + 1, 10))
		elseif what == "PRO_SHOT_58" and axisComponent == -1 then
			setLODDistanceCoeff(math.max(getLODDistanceCoeff() - 1, 1e-06))
		elseif what == "PRO_SHOT_58" and axisComponent == 1 then
			setLODDistanceCoeff(math.min(getLODDistanceCoeff() + 1, 10))
		elseif what == "PRO_SHOT_69" and axisComponent == -1 then
			setTerrainLODDistanceCoeff(math.max(getTerrainLODDistanceCoeff() - 1, 1e-06))
		elseif what == "PRO_SHOT_69" and axisComponent == 1 then
			setTerrainLODDistanceCoeff(math.min(getTerrainLODDistanceCoeff() + 1, 10))
		elseif what == "PRO_SHOT_KP_MINUSPLUS" and axisComponent == -1 then
			setFoliageViewDistanceCoeff(math.max(getFoliageViewDistanceCoeff() - 0.5, 1e-06))
		elseif what == "PRO_SHOT_KP_MINUSPLUS" and axisComponent == 1 then
			setFoliageViewDistanceCoeff(math.min(getFoliageViewDistanceCoeff() + 0.5, 5))
		else
			Logging.info("Unknown menuCallback: " .. tostring(what))
		end
	end
end

function proShot:callbackMenu_sun(what, axisComponent)
	if proShot:keyRepeatThrottle(false, what, axisComponent, 30) then
		local r, g, b = getLightColor(proShot.sun.lightNode)

		if what == "PRO_SHOT_47" and axisComponent == 1 then
			proShot:lightColourChange({0.1, 0, 0}, proShot.sun)
		elseif what == "PRO_SHOT_47" and axisComponent == -1 then
			proShot:lightColourChange({-0.1, 0, 0}, proShot.sun)
		elseif what == "PRO_SHOT_58" and axisComponent == 1 then
			proShot:lightColourChange({0, 0.1, 0}, proShot.sun)
		elseif what == "PRO_SHOT_58" and axisComponent == -1 then
			proShot:lightColourChange({0, -0.1, 0}, proShot.sun)
		elseif what == "PRO_SHOT_69" and axisComponent == 1 then
			proShot:lightColourChange({0, 0, 0.1}, proShot.sun)
		elseif what == "PRO_SHOT_69" and axisComponent == -1 then
			proShot:lightColourChange({0, 0, -0.1}, proShot.sun)

		elseif what == "PRO_SHOT_DOT3" and axisComponent == 1 then
			setMoonSizeScale(math.max(getMoonSizeScale() -  math.max(getMoonSizeScale() / 100, 0.01), 0))
		elseif what == "PRO_SHOT_DOT3" and axisComponent == -1 then
			setMoonSizeScale(math.min(getMoonSizeScale() +  math.max(getMoonSizeScale() / 100, 0.01), 224))

		elseif what == "PRO_SHOT_DIVMUL" and axisComponent == -1 then
			proShot.sun.colourTemp = math.min(math.floor(proShot.sun.colourTemp + proShot.sun.colourTemp / 10), 40000)
			setLightColor(proShot.sun.lightNode, self:colourTempToRGB(proShot.sun.colourTemp, proShot.sun.intensity))
			proShot.sun.colourTempIsPreset = true
		elseif what == "PRO_SHOT_DIVMUL"  and axisComponent == 1 then
			proShot.sun.colourTemp = math.max(math.floor(proShot.sun.colourTemp - proShot.sun.colourTemp / 10), 1000)
			setLightColor(proShot.sun.lightNode, self:colourTempToRGB(proShot.sun.colourTemp, proShot.sun.intensity))
			proShot.sun.colourTempIsPreset = true
		elseif what == "PRO_SHOT_KP_MINUSPLUS"	and axisComponent == -1 then
			proShot:lightIntensityChange(-0.1, proShot.sun)
		elseif what == "PRO_SHOT_KP_MINUSPLUS"	and axisComponent == 1 then
			proShot:lightIntensityChange(0.1, proShot.sun)

		elseif what == "PRO_SHOT_MINUSEQUALS" and axisComponent == 1 then
			setAtmosphereCornettAsymetryFactor(math.min(getAtmosphereCornettAsymetryFactor() + 0.01, 2))
		elseif what == "PRO_SHOT_MINUSEQUALS" and axisComponent == -1 then
			setAtmosphereCornettAsymetryFactor(math.max(getAtmosphereCornettAsymetryFactor() - 0.01, 0))

		elseif what == "PRO_SHOT_SQUAREBRACKETS" and axisComponent == 1 then
			setSunSizeScale(math.max(getSunSizeScale() -  math.max(getSunSizeScale() / 100, 0.01), 0))
		elseif what == "PRO_SHOT_SQUAREBRACKETS" and axisComponent == -1 then
			setSunSizeScale(math.min(getSunSizeScale() + math.max(getSunSizeScale() / 100, 0.01), 2200000))
		elseif what == "PRO_SHOT_BACKSLASH" and axisComponent == 1 then
			local fwyc = proShot.fromWhenceYouCame
			setSunSizeScale(fwyc.sunSizeScale)
			setAtmosphereCornettAsymetryFactor(fwyc.atmosRefraction)
			setMoonSizeScale(fwyc.moonSizeScale)
		else
			Logging.info("Unknown menuCallback: " .. tostring(what))
		end
	end
end

function proShot:callbackMenu_void(what)
end

function proShot:keyRepeatThrottle(isTick, action, axis, lockoutTime)
	if isTick then
		-- Decrease/remove all counters
		for k, v in pairs(proShot.keyLockout) do
			if v.lockoutTime < -10 then
				proShot.keyLockout[k] = nil
			else
				proShot.keyLockout[k].lockoutTime = v.lockoutTime - 1
			end
		end
	else

		-- Locking checking
		if axis == 0 then
			-- keyUp event (Clear any locks, unless we're rebuilding the menu... then it's false keyUps)
			if not proShot.menuRebuilding then
				proShot.keyLockout[action] = nil
			end
			return false
		else
			-- keyDown event
			if proShot.keyLockout[action] == nil then
				-- No lockout present, so let it through, but add new lockout
				proShot.keyLockout[action] = {}
				proShot.keyLockout[action].lockoutTime = lockoutTime
				return true
			else
				if proShot.keyLockout[action].lockoutTime < 1 then
					-- Recent lockout was present
					if proShot.keyLockout[action].repeats then
						-- 2nd+ repeat
						proShot.keyLockout[action].repeats = proShot.keyLockout[action].repeats + 1
						proShot.keyLockout[action].lockoutTime = lockoutTime / proShot.keyLockout[action].repeats
						return true
					else
						-- First repeat
						proShot.keyLockout[action].repeats = 1
						proShot.keyLockout[action].lockoutTime = lockoutTime / 2
						return true
					end
				else
					-- Lockout is active
					return false
				end
			end
		end
	end
end


function proShot:colourTempToRGB(kelvin, intensity)
-- Based on: http://www.tannerhelland.com/4435/convert-temperature-rgb-algorithm-code/
	local r, g, b
	temp = kelvin / 100
	if temp <= 66 then
		r = 255
		g = MathUtil.clamp(99.4708025861 * math.log(temp) - 161.1195681661, 0, 255)
	else
		r = MathUtil.clamp(329.698727446 * math.pow(temp - 60, -0.1332047592), 0, 255)
		g = MathUtil.clamp(288.1221695283 * ((temp - 60) ^ -0.0755148492), 0, 255)
	end

	if temp >= 66 then
		b = 255
	else
		if temp <= 19 then
			b = 0
		else
			b = temp - 10
			b = MathUtil.clamp(138.5177312231 * math.log(b) - 305.0447927307, 0, 255)
		end
	end

	return (r / 255) * intensity, (g / 255) * intensity, (b / 255) * intensity
end

function proShot:lightColourChange(change, light)
	local r, g, b = getLightColor(light.lightNode)
	if light.intensity ~= 0 then
		r, g, b = r / light.intensity, g / light.intensity, b / light.intensity
	end
	r, g, b = MathUtil.clamp((r + change[1]), 0, 1) * light.intensity, MathUtil.clamp((g + change[2]), 0, 1) * light.intensity, MathUtil.clamp((b + change[3]), 0, 1) * light.intensity
	setLightColor(light.lightNode, r, g, b)
	light.colourTempIsPreset = false
end

function proShot:lightIntensityChange(change, light)
	local r, g, b = getLightColor(light.lightNode)
	local r, g, b = getLightColor(light.lightNode)
	if light.intensity ~= 0 then -- just in case
		r, g, b = r / light.intensity, g / light.intensity, b / light.intensity
	end
	light.intensity = MathUtil.clamp(light.intensity + change, 0.0001, 20) -- Don't let it get to 0... or it 0s the rgb
	setLightColor(light.lightNode, r * light.intensity, g * light.intensity, b * light.intensity)
end

function proShot:toggleFlashLight()
	local light = proShot.heldLight.lightNode

	if getVisibility(light) then
		setVisibility(light, false)
		proShot.heldLight.isVisible = false
	else
		setVisibility(light, true)
		proShot.heldLight.isVisible = true
	end
end

function proShot:lightPlace(light)
	if getVisibility(light.lightNode) then
		local r, g, b = getLightColor(light.lightNode)
		local xR, yR, zR = getWorldRotation(light.lightNode)
		local xT, yT, zT = getWorldTranslation(light.lightNode)
		table.insert(proShot.placedLights, light.lightNode)
		link(proShot.lightStand, light.lightNode) -- Place the light on the stand
		-- Restore world coords
		setWorldRotation(light.lightNode, xR, yR, zR)
		setWorldTranslation(light.lightNode, xT, yT, zT)
		-- Rebuild the library, since it's missing a light now
		proShot.lightLibrary = loadI3DFile(proShot.lightI3D,false,false,false)
		-- Grab a new light, same as the old one
		light.lightNode = getChildAt(proShot.lightLibrary, light.variation)
		link(proShot.tripod, light.lightNode)
		-- Set new light to same settings as before
		setWorldRotation(light.lightNode, xR, yR, zR)
		setWorldTranslation(light.lightNode, xT, yT, zT)
		setLightColor(light.lightNode, r, g, b)
		setVisibility(light.lightNode, false) -- Turn off the new light
	else
		-- Just set the light visible and don't drop an invisible light (or one the player hasn't seen)
		setVisibility(light.lightNode, true)
	end
end

function proShot:lightFauxSet(coneAngle, dropOff) -- coneAngle must be in multiples of 10
	local light = proShot.heldLight
	local r, g, b = getLightColor(light.lightNode)
	coneAngle = MathUtil.clamp(coneAngle, 30, 120)
	dropOff = MathUtil.clamp(dropOff, 0, 5)
	link(proShot.lightLibrary, light.lightNode, light.variation) -- Return the light to the librarian
	light.variation = ((coneAngle - 30) / 10) + (dropOff * 10) --  Calculate the light we'd like to check out
	light.lightNode = getChildAt(proShot.lightLibrary, light.variation)
	link(proShot.tripod, light.lightNode) -- Borrow the light
	-- Store changed values
	light.coneAngle = coneAngle
	light.dropOff = dropOff
	-- Apply previous settings to new light
	setVisibility(light.lightNode, light.isVisible)
	setLightColor(light.lightNode, r, g, b)
	setLightRange(light.lightNode, light.range)
	proShot:lightIntensityChange(0, light)
end

function proShot:colorGradingSet(selection)
	local env = g_currentMission.environment

	local xmlFile = XMLFile.load("Environment", env.xmlFilename)
	local lighting = Lighting.new(env)
	lighting:load(xmlFile, "environment.lighting")
	xmlFile:delete()

	if selection == "test" then
		lighting.colorGradingDay = proShot.modDir .. "xml/colorGrading/test.xml"
		lighting.colorGradingNight = lighting.colorGradingDay
		env:setCustomLighting(nil)
	elseif selection ~= nil then
		local selectList = { "flat", "vibrant", "deep", "cold", "greyscale", "sepiaTone", "phantom" }
		lighting.colorGradingDay = proShot.modDir .. "xml/colorGrading/" .. selectList[selection] .. ".xml"
		lighting.colorGradingNight = lighting.colorGradingDay
	else
		lighting.colorGradingDay = proShot.fromWhenceYouCame.colorGradingDay
		lighting.colorGradingNight = lighting.colorGradingDay
	end

	-- Don't reset these to default, in case someone makes a mod to make the night darker... for example
	lighting.moonBrightnessScaleCurveData = env.lighting.moonBrightnessScaleCurveData
	lighting.primaryExtraterrestrialColorCurveData = env.lighting.primaryExtraterrestrialColorCurveData
	lighting.asymmetryFactorCurveData = env.lighting.asymmetryFactorCurveData


	env:setCustomLighting(lighting)
end

function proShot:seasonChange(season)
	local cvp = g_currentMission.environment.currentVisualPeriod
	local id = cvp
	
	if season ~= "init" then
		if season == "tweakUp" then
			proShot.seasonTweak = MathUtil.clamp(proShot.seasonTweak + 0.01, -1, 1)
		elseif season =="tweakDown" then
			proShot.seasonTweak = MathUtil.clamp(proShot.seasonTweak - 0.01, -1, 1)
		else
			proShot.seasonTweak = 0
			if season == "spring" then
				if cvp == 1 then
					id = 2
				elseif cvp == 2 then
					id = 3
				else
					id = 1
				end
			elseif season == "summer" then
				if cvp == 4 then
					id = 5
				elseif cvp == 5 then
					id = 6
				else
					id = 4
				end
			elseif season == "autumn" then
				if cvp == 7 then
					id = 8
				elseif cvp == 8 then
					id = 9
				else
					id = 7
				end
			elseif season == "winter" then
				if cvp == 10 then
					id = 11
				elseif cvp == 11 then
					id = 12
				else
					id = 10
				end
			end

		end

		g_currentMission.environment.currentVisualPeriod = id
		g_currentMission.environment.currentVisualSeason = math.floor(id / 3.3)
		
		local periodToShader = { 3.11, 3.33, 3.67, 3.95, 0.6, 0.85, 1.08, 1.42, 1.75, 2, 2.25, 2.65 }
		local shaderParam = periodToShader[id] + proShot.seasonTweak
		if shaderParam > 4 then
			shaderParam = shaderParam - 4
		elseif shaderParam < 0 then
			shaderParam = shaderParam + 4
		end
		
		setSharedShaderParameter(Shader.PARAM_SHARED_SEASON, shaderParam)
		proShot.menuCurrent = "updateTextOnly"
	else
		proShot.menuCurrent = "noneAtAll"
	end
	
	-- Update dynamic menu
	if id == 3 or id == 6 or id == 9 or id == 12 then
		proShot.dynamicMenuNames.spring = g_i18n:getText("proShot_spring") .. " (" .. g_i18n:getText("proShot_early") .. ")"
		proShot.dynamicMenuNames.summer = g_i18n:getText("proShot_summer") .. " (" .. g_i18n:getText("proShot_early") .. ")"
		proShot.dynamicMenuNames.autumn = g_i18n:getText("proShot_autumn") .. " (" .. g_i18n:getText("proShot_early") .. ")"
		proShot.dynamicMenuNames.winter = g_i18n:getText("proShot_winter") .. " (" .. g_i18n:getText("proShot_early") .. ")"
	elseif id == 1 then 
		proShot.dynamicMenuNames.spring = g_i18n:getText("proShot_spring") .. " (" .. g_i18n:getText("proShot_mid") .. ")"
		proShot.dynamicMenuNames.summer = g_i18n:getText("proShot_summer") .. " (" .. g_i18n:getText("proShot_early") .. ")"
		proShot.dynamicMenuNames.autumn = g_i18n:getText("proShot_autumn") .. " (" .. g_i18n:getText("proShot_early") .. ")"
		proShot.dynamicMenuNames.winter = g_i18n:getText("proShot_winter") .. " (" .. g_i18n:getText("proShot_early") .. ")"
	elseif id == 2 then
		proShot.dynamicMenuNames.spring = g_i18n:getText("proShot_spring") .. " (" .. g_i18n:getText("proShot_late") .. ")"
		proShot.dynamicMenuNames.summer = g_i18n:getText("proShot_summer") .. " (" .. g_i18n:getText("proShot_early") .. ")"
		proShot.dynamicMenuNames.autumn = g_i18n:getText("proShot_autumn") .. " (" .. g_i18n:getText("proShot_early") .. ")"
		proShot.dynamicMenuNames.winter = g_i18n:getText("proShot_winter") .. " (" .. g_i18n:getText("proShot_early") .. ")"
	elseif id == 4 then
		proShot.dynamicMenuNames.spring = g_i18n:getText("proShot_spring") .. " (" .. g_i18n:getText("proShot_early") .. ")"
		proShot.dynamicMenuNames.summer = g_i18n:getText("proShot_summer") .. " (" .. g_i18n:getText("proShot_mid") .. ")"
		proShot.dynamicMenuNames.autumn = g_i18n:getText("proShot_autumn") .. " (" .. g_i18n:getText("proShot_early") .. ")"
		proShot.dynamicMenuNames.winter = g_i18n:getText("proShot_winter") .. " (" .. g_i18n:getText("proShot_early") .. ")"
	elseif id == 5 then
		proShot.dynamicMenuNames.spring = g_i18n:getText("proShot_spring") .. " (" .. g_i18n:getText("proShot_early") .. ")"
		proShot.dynamicMenuNames.summer = g_i18n:getText("proShot_summer") .. " (" .. g_i18n:getText("proShot_late") .. ")"
		proShot.dynamicMenuNames.autumn = g_i18n:getText("proShot_autumn") .. " (" .. g_i18n:getText("proShot_early") .. ")"
		proShot.dynamicMenuNames.winter = g_i18n:getText("proShot_winter") .. " (" .. g_i18n:getText("proShot_early") .. ")"
	elseif id == 7 then
		proShot.dynamicMenuNames.spring = g_i18n:getText("proShot_spring") .. " (" .. g_i18n:getText("proShot_early") .. ")"
		proShot.dynamicMenuNames.summer = g_i18n:getText("proShot_summer") .. " (" .. g_i18n:getText("proShot_early") .. ")"
		proShot.dynamicMenuNames.autumn = g_i18n:getText("proShot_autumn") .. " (" .. g_i18n:getText("proShot_mid") .. ")"
		proShot.dynamicMenuNames.winter = g_i18n:getText("proShot_winter") .. " (" .. g_i18n:getText("proShot_early") .. ")"
	elseif id == 8 then
		proShot.dynamicMenuNames.spring = g_i18n:getText("proShot_spring") .. " (" .. g_i18n:getText("proShot_early") .. ")"
		proShot.dynamicMenuNames.summer = g_i18n:getText("proShot_summer") .. " (" .. g_i18n:getText("proShot_early") .. ")"
		proShot.dynamicMenuNames.autumn = g_i18n:getText("proShot_autumn") .. " (" .. g_i18n:getText("proShot_late") .. ")"
		proShot.dynamicMenuNames.winter = g_i18n:getText("proShot_winter") .. " (" .. g_i18n:getText("proShot_early") .. ")"
	elseif id == 10 then
		proShot.dynamicMenuNames.spring = g_i18n:getText("proShot_spring") .. " (" .. g_i18n:getText("proShot_early") .. ")"
		proShot.dynamicMenuNames.summer = g_i18n:getText("proShot_summer") .. " (" .. g_i18n:getText("proShot_early") .. ")"
		proShot.dynamicMenuNames.autumn = g_i18n:getText("proShot_autumn") .. " (" .. g_i18n:getText("proShot_early") .. ")"
		proShot.dynamicMenuNames.winter = g_i18n:getText("proShot_winter") .. " (" .. g_i18n:getText("proShot_mid") .. ")"
	elseif id == 11 then
		proShot.dynamicMenuNames.spring = g_i18n:getText("proShot_spring") .. " (" .. g_i18n:getText("proShot_early") .. ")"
		proShot.dynamicMenuNames.summer = g_i18n:getText("proShot_summer") .. " (" .. g_i18n:getText("proShot_early") .. ")"
		proShot.dynamicMenuNames.autumn = g_i18n:getText("proShot_autumn") .. " (" .. g_i18n:getText("proShot_early") .. ")"
		proShot.dynamicMenuNames.winter = g_i18n:getText("proShot_winter") .. " (" .. g_i18n:getText("proShot_late") .. ")"
	end
end

function proShot:weatherChange(weatherName, isInit)
	local weather = g_currentMission.environment.weather
	local currentSeason = g_currentMission.environment.currentSeason
	local currentWeatherInstance = weather.forecastItems[1]
	local variationIndex = 1
	local nextVariationIndex = 2
	
	if weatherName == g_weatherTypeManager.indexToName[g_currentMission.environment.weather:getWeatherTypeAtTime(g_currentMission.environment.currentMonotonicDay, g_currentMission.environment.dayTime)] then
		local numVariations = #weather.weatherObjects[currentWeatherInstance.season][currentWeatherInstance.objectIndex].variations
		if isInit == true then
			variationIndex = currentWeatherInstance.variationIndex
		else
			variationIndex = currentWeatherInstance.variationIndex + 1
		end
		if variationIndex > numVariations then
			variationIndex = 1
		end
		nextVariationIndex = variationIndex + 1
		if nextVariationIndex > numVariations then
			nextVariationIndex = 1
		end
	end
	
	if weatherName == "SUN" then
		proShot.dynamicMenuNames.sunny = g_i18n:getText("proShot_weather_SUN") .. " (" .. nextVariationIndex .. ")"
		proShot.dynamicMenuNames.cloudy = g_i18n:getText("proShot_weather_CLOUDY") .. " (1)"
		proShot.dynamicMenuNames.rainy = g_i18n:getText("proShot_weather_RAIN") .. " (1)"
		proShot.dynamicMenuNames.snowy = g_i18n:getText("proShot_weather_SNOW") .. " (1)"
	elseif weatherName == "CLOUDY" then
		proShot.dynamicMenuNames.sunny = g_i18n:getText("proShot_weather_SUN") .. " (1)"
		proShot.dynamicMenuNames.cloudy = g_i18n:getText("proShot_weather_CLOUDY") .. " (" .. nextVariationIndex .. ")"
		proShot.dynamicMenuNames.rainy = g_i18n:getText("proShot_weather_RAIN") .. " (1)"
		proShot.dynamicMenuNames.snowy = g_i18n:getText("proShot_weather_SNOW") .. " (1)"
	elseif weatherName == "RAIN" then
		proShot.dynamicMenuNames.sunny = g_i18n:getText("proShot_weather_SUN") .. " (1)"
		proShot.dynamicMenuNames.cloudy = g_i18n:getText("proShot_weather_CLOUDY") .. " (1)"
		proShot.dynamicMenuNames.rainy = g_i18n:getText("proShot_weather_RAIN") .. " (" .. nextVariationIndex .. ")"
		proShot.dynamicMenuNames.snowy = g_i18n:getText("proShot_weather_SNOW") .. " (1)"
	elseif weatherName == "SNOW" then
		proShot.dynamicMenuNames.sunny = g_i18n:getText("proShot_weather_SUN") .. " (1)"
		proShot.dynamicMenuNames.cloudy = g_i18n:getText("proShot_weather_CLOUDY") .. " (1)"
		proShot.dynamicMenuNames.rainy = g_i18n:getText("proShot_weather_RAIN") .. " (1)"
		proShot.dynamicMenuNames.snowy = g_i18n:getText("proShot_weather_SNOW") .. " (" .. nextVariationIndex .. ")"
	end
	
	if isInit == true then
		return
	end
	
	proShot.menuCurrent = "updateTextOnly"
	
	local currentWeatherObject = nil

	if currentWeatherInstance ~= nil then
		currentWeatherObject = weather:getWeatherObjectByIndex(currentWeatherInstance.season, currentWeatherInstance.objectIndex)
	end

	weather.forecastItems = {}

	local weatherObject = weather.typeToWeatherObject[currentSeason][g_weatherTypeManager.nameToIndex[weatherName]]
	if weatherObject == nil then
		if weatherName == "SNOW" then
			weatherObject = weather.typeToWeatherObject[Environment.SEASON["WINTER"]][g_weatherTypeManager.nameToIndex[weatherName]]
			currentSeason = Environment.SEASON["WINTER"]
		elseif weatherName == "RAIN" then
			weatherObject = weather.typeToWeatherObject[Environment.SEASON["SUMMER"]][g_weatherTypeManager.nameToIndex[weatherName]]
			currentSeason = Environment.SEASON["SUMMER"]
		end
	end

	if weatherObject ~= nil then
		local variation = weatherObject:getVariationByIndex(variationIndex)

		if variation == nil then
			variation = weatherObject:getVariationByIndex(weatherObject:getRandomVariationIndex())
		end

		local duration = MathUtil.hoursToMs(math.random(variation.minHours, variation.maxHours))
		local index = 3
		local currentInstance = weather.forecastItems[2]

		if currentInstance == nil then
			currentInstance = weather.forecastItems[1]
			index = 2

			if currentInstance == nil then
				index = 1
			end
		end

		local startDay = weather.owner.currentMonotonicDay
		local startDayTime = weather.owner.dayTime

		if currentInstance ~= nil then
			startDayTime = currentInstance.startDayTime
			startDay = currentInstance.startDay
		end

		startDay, startDayTime = weather.owner:getDayAndDayTime(startDayTime + duration, startDay)
		local instance = WeatherInstance.createInstance(weatherObject.index, variation.index, startDay, startDayTime, duration, currentSeason)

		table.insert(weather.forecastItems, index, instance)
		weather:fillWeatherForecast()

		if currentWeatherObject ~= nil then
			currentWeatherObject:deactivate(1)
			currentWeatherObject:update(9999999)
		end

		weather:init()
	end

	g_currentMission.environment:update(g_currentDt)
end

function proShot:timeChange(ms)
	local env = g_currentMission.environment
	
	if ms > 86400000 then
		ms = ms - 86400000
	elseif ms < 0 then
		ms = ms + 86400000
	end
	
	env:setEnvironmentTime(env.currentMonotonicDay, env.currentDay, ms, env.daysPerPeriod, false)
	env:update(g_currentDt)
end

function proShot:snowBusiness(height)
	local x, _, z = getWorldTranslation(proShot.tripod)

	if height == "getHeight" then
		local radius = 10
		local startWorldX = x - radius
		local startWorldZ = z - radius
		local widthWorldX = x + radius
		local widthWorldZ = z - radius
		local heightWorldX = x - radius
		local heightWorldZ = z + radius
		return SnowSystem.getSnowHeightAtArea(g_currentMission.snowSystem, startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ)
	else
		local radius = 100
		local startWorldX = x - radius
		local startWorldZ = z - radius
		local widthWorldX = x + radius
		local widthWorldZ = z - radius
		local heightWorldX = x - radius
		local heightWorldZ = z + radius
		SnowSystem.setSnowHeightAtArea(g_currentMission.snowSystem, startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, MathUtil.clamp(height, 0, 4))
		
		local snowShaderValue = g_currentMission.snowSystem.snowShaderValue
		SnowSystem.setSnowHeight(g_currentMission.snowSystem, height)
		setSharedShaderParameter(Shader.PARAM_SHARED_SNOW, snowShaderValue)
		g_currentMission.snowSystem.snowShaderValue = snowShaderValue
	end
end



function proShot:updateControlsMenu()
	if proShot.menuCurrent ~= proShot.menuDesired then
		
		-- Remove events only if doing a full rebuild
		if proShot.menuCurrent ~= "updateTextOnly" then
			-- Remove all of our actions
			proShot.menuRebuilding = true
			for key, eventId in pairs(proShot.buttonId) do
				g_inputBinding:removeActionEvent(eventId)
				proShot.buttonId[key] = nil
			end
			proShot.menuRebuilding = false
		end

		g_inputBinding:beginActionEventsModification(BaseMission.INPUT_CONTEXT_PAUSE)
		local count = 0

		-- Loop through desired menu items
		for _, item in ipairs(proShot.menus[proShot.menuDesired]) do
			count = count + 1
			local eventId = 0
			if proShot.buttonId[item[1]] == nil then -- Add new
				_, eventId = g_inputBinding:registerActionEvent(InputAction[item[1]], self, self[item[2]], true, true, true, true)
				proShot.buttonId[item[1]] = eventId
				g_inputBinding:setActionEventActive(eventId, true)
				g_inputBinding:setActionEventTextPriority(eventId, item[4])
			else
				eventId = proShot.buttonId[item[1]] -- Use existing
			end

			-- Set/update text
			if type(item[3]) == "table" then
				g_inputBinding:setActionEventText(eventId, proShot.dynamicMenuNames[item[3][1]])
			else
				g_inputBinding:setActionEventText(eventId, item[3])
			end
		end

		if proShot.menuDesired == "main" then
			count = count + 2 -- Display the unpause and menu options, for the main menu only
		end
		InputHelpDisplay.ENTRY_COUNT_PC = count

		g_inputBinding:endActionEventsModification()

		proShot.menuCurrent = proShot.menuDesired
	end
end

function proShot:updateInfoBox()
	if g_currentMission.hud.isVisible then
		local box = g_currentMission.player.hudUpdater.fieldBox
		if proShot.menuCurrent == "main" then
			local r, g, b = getLightColor(proShot.sun.lightNode)
			r, g, b = r / proShot.sun.intensity, g / proShot.sun.intensity, b / proShot.sun.intensity
			local sunK
			if proShot.sun.colourTempIsPreset then
				sunK = proShot.sun.colourTemp .. "K"
			elseif math.floor(r * 100) / 100 == math.floor(g * 100) / 100 and math.floor(g * 100) / 100 == math.floor(b * 100) / 100 then
				sunK = "6600K"
			else
				sunK = g_i18n:getText("info_transmission_manual")
			end

			box:clear()
			box:setTitle(g_i18n:getText("ui_inGameMenuControls"))
			box:addLine(g_i18n:getText("proShot_infoBox_help1a"), g_i18n:getText("proShot_infoBox_help1b"), true)
			box:addLine(g_i18n:getText("proShot_infoBox_help2a"), g_i18n:getText("proShot_infoBox_help2b"), true)
			box:addLine(g_i18n:getText("proShot_infoBox_help3a"), g_i18n:getText("proShot_infoBox_help3b"), true, {0, 0.565, 0.973, 0.7})
			box:addLine(g_i18n:getText("proShot_infoBox_help4a"), g_i18n:getText("proShot_infoBox_help4b"), true, {0, 0.565, 0.973, 0.7})
			box:addLine(g_i18n:getText("proShot_infoBox_help5a"), g_i18n:getText("proShot_infoBox_help5b"), true)
			box:addLine(g_i18n:getText("proShot_infoBox_help6a"), g_i18n:getText("proShot_infoBox_help6b"), true)
			box:addLine(g_i18n:getText("proShot_infoBox_help7a"), g_i18n:getText("proShot_infoBox_help7b"), true)
			box:addLine(g_i18n:getText("proShot_infoBox_help8a"), g_i18n:getText("proShot_infoBox_help8b"), true)
			box:addLine(g_i18n:getText("proShot_infoBox_sunTemp"), sunK)
			box:addLine(g_i18n:getText("proShot_infoBox_sunIntensity"), string.format("%.1f", proShot.sun.intensity))
			box:addLine(g_i18n:getText("proShot_infoBox_exposure"), string.format("%+.1f", proShot.exposureMinValue))
			box:addLine(g_i18n:getText("proShot_infoBox_FoV"), tostring(proShot.FoV))
			box:draw(1 - g_safeFrameOffsetX, g_safeFrameOffsetY)
		elseif proShot.menuCurrent == "advQuality" then
			box:clear()
			box:setTitle(g_i18n:getText("proShot_infoBox_title_currentSettings"))
			box:addLine(g_i18n:getText("proShot_infoBox_VD"), string.format("%.2f", getViewDistanceCoeff()))
			box:addLine(g_i18n:getText("proShot_infoBox_LOD"), string.format("%.2f", getLODDistanceCoeff()))
			box:addLine(g_i18n:getText("proShot_infoBox_TLOD"), string.format("%.2f", getTerrainLODDistanceCoeff()))
			box:addLine(g_i18n:getText("proShot_infoBox_FVD"), string.format("%.2f", getFoliageViewDistanceCoeff()))
			box:draw(1 - g_safeFrameOffsetX, g_safeFrameOffsetY)
		elseif proShot.menuCurrent == "sun" then
			local r, g, b = getLightColor(proShot.sun.lightNode)
			if proShot.sun.intensity ~= 0 then
				r, g, b = r / proShot.sun.intensity, g / proShot.sun.intensity, b / proShot.sun.intensity
			end
			local sunK
			if proShot.sun.colourTempIsPreset then
				sunK = proShot.sun.colourTemp .. "K"
			elseif math.floor(r * 100) / 100 == math.floor(g * 100) / 100 and math.floor(g * 100) / 100 == math.floor(b * 100) / 100 then
				sunK = "6600K"
			else
				sunK = g_i18n:getText("info_transmission_manual")
			end

			box:clear()
			box:setTitle(g_i18n:getText("proShot_infoBox_title_sun"))
			box:addLine(g_i18n:getText("proShot_infoBox_sunTemp"), sunK)
			box:addLine(g_i18n:getText("proShot_infoBox_sunIntensity"), string.format("%.1f", proShot.sun.intensity))
			box:addLine(g_i18n:getText("ui_colorRed"), math.floor(r * 100 + 0.5) .. "%", true, {1, 0.2, 0.2, 1})
			box:addLine(g_i18n:getText("ui_colorGreen"), math.floor(g * 100 + 0.5) .. "%", true, {0.2, 1, 0.2, 1})
			box:addLine(g_i18n:getText("ui_colorBlue"), math.floor(b * 100 + 0.5) .. "%", true, {0.2, 0.2, 1, 1})

			box:addLine(g_i18n:getText("proShot_menu_sunSize"), string.format("%.2f", math.sqrt(23000 / getSunSizeScale())))

			local moonSize = math.sqrt(36 / getMoonSizeScale())
			if moonSize < 0.7 then
				moonSize = moonSize - (0.7 - moonSize)
			end
			box:addLine(g_i18n:getText("proShot_menu_moonSize"), string.format("%.2f", moonSize))
			box:addLine(g_i18n:getText("proShot_menu_atmosRefraction"), string.format("%.2f", getAtmosphereCornettAsymetryFactor()))

			box:draw(1 - g_safeFrameOffsetX, g_safeFrameOffsetY)
		elseif proShot.menuCurrent == "flashLight" then
			local light = proShot.heldLight
			local r, g, b = getLightColor(light.lightNode)
			if light.intensity ~= 0 then
				r, g, b = r / light.intensity, g / light.intensity, b / light.intensity
			end
			local lightK
			if light.colourTempIsPreset then
				lightK = light.colourTemp .. "K"
			elseif r == 1 and g == 1 and b == 1 then
				lightK = "6600K"
			else
				lightK = g_i18n:getText("info_transmission_manual")
			end

			box:clear()
			box:setTitle(g_i18n:getText("proShot_infoBox_title_flashlight"))
			box:addLine(g_i18n:getText("proShot_infoBox_flashlightTemp"), lightK)
			box:addLine(g_i18n:getText("proShot_infoBox_flashlightIntensity"), string.format("%.1f", light.intensity))
			box:addLine(g_i18n:getText("proShot_infoBox_flashlightRange"), tostring(light.range))
			box:addLine(g_i18n:getText("proShot_infoBox_flashlightCone"), tostring(light.coneAngle))
			box:addLine(g_i18n:getText("proShot_infoBox_flashlightDropOff"), tostring(light.dropOff))
			box:addLine(g_i18n:getText("ui_colorRed"), math.floor(r * 100 + 0.5) .. "%", true, {1, 0.2, 0.2, 1})
			box:addLine(g_i18n:getText("ui_colorGreen"), math.floor(g * 100 + 0.5) .. "%", true, {0.2, 1, 0.2, 1})
			box:addLine(g_i18n:getText("ui_colorBlue"), math.floor(b * 100 + 0.5) .. "%", true, {0.2, 0.2, 1, 1})
			box:draw(1 - g_safeFrameOffsetX, g_safeFrameOffsetY)
		elseif proShot.menuCurrent == "environment" then
			local env = g_currentMission.environment
			local cvs = env.currentVisualSeason
			local cvp = env.currentVisualPeriod
			local sp = cvp - cvs * 3
			local seasonName = ''
			local seasonPart = ''
			
			if sp == 1 then
				seasonPart = g_i18n:getText("proShot_early")
			elseif sp == 2 then
				seasonPart = g_i18n:getText("proShot_mid")
			else
				seasonPart = g_i18n:getText("proShot_late")
			end
			
			if cvs == 0 then
				seasonName = g_i18n:getText("proShot_spring") .. " (" .. seasonPart .. ")"
			elseif cvs == 1 then
				seasonName = g_i18n:getText("proShot_summer") .. " (" .. seasonPart .. ")"
			elseif cvs == 2 then
				seasonName = g_i18n:getText("proShot_autumn") .. " (" .. seasonPart .. ")"
			elseif cvs == 3 then
				seasonName = g_i18n:getText("proShot_winter") .. " (" .. seasonPart .. ")"
			end
			
			box:clear()
			box:setTitle(g_i18n:getText("proShot_infoBox_title_environment"))
			box:addLine(g_i18n:getText("proShot_infoBox_season"), seasonName)
			box:addLine(g_i18n:getText("proShot_seasonTweak"), string.format("%+.2f", proShot.seasonTweak))
			box:addLine(g_i18n:getText("proShot_infoBox_weather"), g_i18n:getText("proShot_weather_" .. g_weatherTypeManager.indexToName[env.weather:getWeatherTypeAtTime(env.currentMonotonicDay, env.dayTime)]))
			box:addLine(g_i18n:getText("proShot_infoBox_weather") .. " " .. g_i18n:getText("proShot_variation"), tostring(env.weather.forecastItems[1].variationIndex))
			box:addLine(g_i18n:getText("proShot_infoBox_time"), string.format("%d:%02d", env.currentHour, env.currentMinute))
			box:addLine(g_i18n:getText("proShot_infoBox_frostAmount"), tostring(math.floor(g_currentMission.snowSystem.snowShaderValue * 100 + 0.5)) .. "%")
			box:addLine(g_i18n:getText("proShot_infoBox_snowLevel"), string.format("%.2f", proShot:snowBusiness("getHeight")))
			box:draw(1 - g_safeFrameOffsetX, g_safeFrameOffsetY)
		elseif proShot.menuCurrent == "DoF" then
			local nearCoCRadius, nearBlurEnd, farCoCRadius, farBlurStart, farBlurEnd, applyToSky = unpack(g_depthOfFieldManager.currentState)
			
			box:clear()
			box:setTitle(g_i18n:getText("proShot_infoBox_title_environment"))
			box:addLine(g_i18n:getText("proShot_DoF_nearCoCRadius"), string.format("%.1f", nearCoCRadius))
			box:addLine(g_i18n:getText("proShot_DoF_nearBlurEnd"), string.format("%.1f", nearBlurEnd))
			box:addLine(g_i18n:getText("proShot_DoF_farCoCRadius"), string.format("%.1f", farCoCRadius))
			box:addLine(g_i18n:getText("proShot_DoF_farBlurStart"), string.format("%.0f", farBlurStart))
			box:addLine(g_i18n:getText("proShot_DoF_farBlurEnd"), string.format("%.0f", farBlurEnd))
			box:addLine(g_i18n:getText("proShot_DoF_applyToSky"), tostring(applyToSky))
			box:draw(1 - g_safeFrameOffsetX, g_safeFrameOffsetY)
		elseif proShot.menuCurrent == "effects" then
			box:clear()
			box:setTitle(g_i18n:getText("proShot_infoBox_title_effects"))
			box:addLine(g_i18n:getText("proShot_menu_effects_bloomThreshold"), string.format("%.1f", getBloomMaskThreshold()))
			box:addLine(g_i18n:getText("proShot_menu_effects_bloomMagnitude"), string.format("%.1f", getBloomMagnitude()))
			box:addLine(g_i18n:getText("proShot_menu_effects_bloomQuality"), string.format("%.0f", getBloomQuality()))
			box:addLine(g_i18n:getText("proShot_menu_effects_SSAOIntensity"), string.format("%.1f", getSSAOIntensity()))
			box:draw(1 - g_safeFrameOffsetX, g_safeFrameOffsetY)
		end
	end
end

function proShot:captureScreen()
	local proShotScreenshotDir = g_screenshotsDirectory.."ProShot"
	createFolder(proShotScreenshotDir)
	local screenshotName = proShotScreenshotDir.."/proShot_"..getDate("%Y-%m-%d_%H-%M-%S")..".png"
	print("Saving screenshot: " .. screenshotName)
	playSample(proShot.cameraSound, 1, 1, 0, 0, 0)
	saveScreenshot(screenshotName)
end

function proShot:camMoveKeys(cam)
	local speed = 0.1
	local rotspeed = 0.015
	if Input.isKeyPressed(Input.KEY_lshift) or Input.isKeyPressed(Input.KEY_rshift) then
		speed = speed * 10
		rotspeed = rotspeed * 5
	elseif Input.isKeyPressed(Input.KEY_lctrl) or Input.isKeyPressed(Input.KEY_rctrl) then
		speed = speed * 0.1
		rotspeed = rotspeed * 0.1
	end

	-- Rotation
	local _, _, zR = getRotation(cam)
	if Input.isKeyPressed(Input.KEY_KP_1) then
		_, _, zR = getRotation(getChildAt(cam, 0))
		setRotation(getChildAt(cam, 0), 0, 0, zR + rotspeed)
	elseif Input.isKeyPressed(Input.KEY_KP_2) then
		_, _, zR = getRotation(getChildAt(cam, 0))
		setRotation(getChildAt(cam, 0), 0, 0, zR - rotspeed)
	elseif Input.isKeyPressed(Input.KEY_KP_0) then
		setRotation(getChildAt(cam, 0), 0, 0, 0)
	end

	-- Translation control
	local xD, yD, zD = 0, 0, 0
	-- Height
	if Input.isKeyPressed(Input.KEY_q) then
		yD = 1
	elseif Input.isKeyPressed(Input.KEY_e) then
		yD = -1
	end
	-- Left/Right Forwards/Back
	if Input.isKeyPressed(Input.KEY_w) then
		zD = -1
	elseif Input.isKeyPressed(Input.KEY_s) then
		zD = 1
	end
	if Input.isKeyPressed(Input.KEY_a) then
		xD = -1
	elseif Input.isKeyPressed(Input.KEY_d) then
		xD = 1
	end
	local xL, yL ,zL = localDirectionToWorld(cam, xD, yD, zD)
	local x, y, z = getTranslation(cam)
	setTranslation(cam, x + (speed * xL), y + (speed * yL), z + (speed * zL))
end

function proShot:camMoveMouse(cam, posX, posY, mouseButtonDown)
	local speed = 1
	if Input.isKeyPressed(Input.KEY_lshift) or Input.isKeyPressed(Input.KEY_rshift) then
		speed = speed * 10
	elseif Input.isKeyPressed(Input.KEY_lctrl) or Input.isKeyPressed(Input.KEY_rctrl) then
		speed = speed * 0.1
	end

	local xChange = (posX - 0.5)
	local yChange = (posY - 0.5)

	-- Rotate
	if mouseButtonDown[3] then
		local xR, yR, zR = getRotation(cam)
		if proShot.invertRotY then
			setRotation(cam, xR + yChange, yR - xChange, zR)
		else
			setRotation(cam, xR + yChange, yR + xChange, zR)
		end
	end

	-- Height
	if mouseButtonDown[4] or mouseButtonDown[5] then
		local xT, yT, zT = getTranslation(cam)
		local xL, yL ,zL
		if mouseButtonDown[5] then
			xL, yL ,zL = localDirectionToWorld(cam, 0, -0.05, 0)
		else
			xL, yL ,zL = localDirectionToWorld(cam, 0, 0.05, 0)
		end
		setTranslation(cam, xT + (speed * xL), yT + (speed * yL), zT + (speed * zL))
	end

	-- Rotate the sun
	if mouseButtonDown[2] then
		setRotation(proShot.calc1, 0, 0, 0) -- Zero
		setWorldRotation(proShot.calc2, getWorldRotation(proShot.sun.lightNode)) -- Take reading and calibrate calculator
		setRotation(proShot.calc1, yChange, 0 - xChange, 0) -- Apply transform to calc
		setWorldRotation(proShot.sun.lightNode, getWorldRotation(proShot.calc2)) -- Read the result and apply to the sun
	end

	-- Move
	if mouseButtonDown[1] then
		local xT, yT, zT = getTranslation(cam)
		local xL, yL ,zL = localDirectionToWorld(cam, xChange, 0, 0 - yChange)
		setTranslation(cam, xT + (speed * xL), yT + (speed * yL), zT + (speed * zL))
	end
end

function proShot:inputKeyboardUpdate()
	if Input.isKeyPressed(Input.KEY_return) and proShot.captureCoolDown < 1 then
		proShot.captureCoolDown = 40
		if g_currentMission.hud.isVisible then
			proShot.reEnableHUD = true
			g_currentMission.hud.isVisible = false
		end
	end

	if proShot.F1throttle > 1 then
		proShot.F1throttle = proShot.F1throttle - 1
	else
		if Input.isKeyPressed(Input.KEY_f1) then
			if g_currentMission.hud.isVisible then
				g_currentMission.hud.isVisible = false
				proShot.F1throttle = 10
			else
				g_currentMission.hud.isVisible = true
				proShot.F1throttle = 10
			end
		end
	end

	proShot:camMoveKeys(proShot.tripod)

	-- Debug - dump mode variables to log
	if Input.isKeyPressed(Input.KEY_lctrl) and Input.isKeyPressed(Input.KEY_lalt) and Input.isKeyPressed(Input.KEY_d) then
		Logging.info("===== Dropping debug info for ProShot mod to console =====")
		DebugUtil.printTableRecursively(proShot, " ", 0, 10)
		Logging.info(string.format("Previous camera Rot: x: %f, y: %f, z: %f", getWorldRotation(proShot.previousCamera)))
		Logging.info(string.format("Previous camera Transt: x: %f, y: %f, z: %f", getWorldTranslation(proShot.previousCamera)))
		Logging.info(string.format("Current camera Rot: x: %f, y: %f, z: %f", getWorldRotation(proShot.tripod)))
		Logging.info(string.format("Current camera Trans: x: %f, y: %f, z: %f", getWorldTranslation(proShot.tripod)))
		Logging.info("===== End debug info for ProShot mod =====")
	end

	-- Vehicle reset
	if proShot.vehicleReloadThrottle > 1 then
		proShot.vehicleReloadThrottle = proShot.vehicleReloadThrottle - 1
	else
		if (Input.isKeyPressed(Input.KEY_lalt) or Input.isKeyPressed(Input.KEY_ralt)) and (Input.isKeyPressed(Input.KEY_lshift) or Input.isKeyPressed(Input.KEY_rshift)) and Input.isKeyPressed(Input.KEY_r) then
			local radius
			if (Input.isKeyPressed(Input.KEY_lctrl) or Input.isKeyPressed(Input.KEY_rctrl)) then
				Logging.info("ProShot: Reloading all vehicles within 100m of camera")
				radius = "100"
			else
				Logging.info("ProShot: Reloading all vehicles within 10m of camera")
				radius = "10"
			end
			proShot.vehicleReloadThrottle = 50

			-- Backup and fudge some things, so it measures the radius from the ProShot camera
			local resetBackups = {}
			if g_currentMission.controlledVehicle ~= nil then
				resetBackups.backupControlledVehicleRootNode = g_currentMission.controlledVehicle.rootNode
				g_currentMission.controlledVehicle.rootNode = proShot.tripod
			else
				resetBackups.backupPlayerRootNode = g_currentMission.player.rootNode
				g_currentMission.player.rootNode = proShot.tripod
			end

			-- Call the console command
			FSBaseMission.consoleCommandReloadVehicle(g_currentMission, "false", radius)

			-- Restore the things we fudged
			if resetBackups.backupControlledVehicleRootNode ~= nil then
				g_currentMission.controlledVehicle.rootNode = resetBackups.backupControlledVehicleRootNode
			end
			if resetBackups.backupPlayerRootNode ~= nil then
				g_currentMission.player.rootNode = resetBackups.backupPlayerRootNode
			end
		elseif (Input.isKeyPressed(Input.KEY_lalt) or Input.isKeyPressed(Input.KEY_ralt)) and Input.isKeyPressed(Input.KEY_r) then
			if g_currentMission.controlledVehicle then
				Logging.info("Reloading active vehicle")
				proShot.vehicleReloadThrottle = 50
				FSBaseMission.consoleCommandReloadVehicle(g_currentMission)
			else
				Logging.info("You're not in a vehicle. Try shift+alt+R")
			end
		end
	end

	-- Placeable reset
	if proShot.placeableReloadThrottle > 1 then
		proShot.placeableReloadThrottle = proShot.placeableReloadThrottle - 1
	else
		if (Input.isKeyPressed(Input.KEY_lalt) or Input.isKeyPressed(Input.KEY_ralt)) and Input.isKeyPressed(Input.KEY_p) then
			Logging.info("ProShot: Reloading all placeables")
			PlaceableSystem.consoleCommandReloadAllPlaceables(g_currentMission.placeableSystem)
			proShot.placeableReloadThrottle = 50
		end
	end
end

function proShot:checkInvertRotY()
	local xPC, yPC, zPC = getWorldRotation(proShot.previousCamera)
	if g_currentMission.controlledVehicle ~= nil then
		if g_currentMission.controlledVehicle.getActiveCamera ~= nil then
				-- In vehicle
				if zPC < 1 and zPC > -1 then
					return true
				else
					return false
				end
		end
	elseif zPC == 0 then
		return true
	else
		return false
	end
end


-- Setup when entering pause state
function proShot:setOnPause()
	proShot.heldLight = {
		["lightNode"] = 0,
		["variation"] = 33,
		["intensity"] = 1,
		["isVisible"] = false,
		["colourTemp"] = 6600,
		["colourTempIsPreset"] = true,
		["coneAngle"] = 60,
		["dropOff"] = 3,
		["range"] = 20,
		["colour"] = {1, 1, 1}
	}
	proShot.sun = {
		["lightNode"] = 0,
		["intensity"] = 1,
		["colourTemp"] = 6600,
		["colourTempIsPreset"] = false,
		["colour"] = {1, 1, 1}
	}

	-- Set some starting values
	proShot.sun.colourTemp = 6600
	proShot.sun.lightNode = g_currentMission.environment.baseLighting.sunLightId
	local rSun, gSun, bSun = getLightColor(proShot.sun.lightNode)
	proShot.sun.intensity = (rSun + gSun + bSun) / 3 -- Close enough, probably
	proShot.menuCurrent = "noneAtAll"
	proShot.menuDesired = "main"
	proShot.seasonTweak = 0


	local keyValue, minExposure, _ = g_currentMission.environment.lighting.autoExposureCurve:get(g_currentMission.environment.dayTime / 60000)
	proShot.exposureKeyValue = g_currentMission.environment.lighting.fixedKeyValue or keyValue
	proShot.exposureMinValue = g_currentMission.environment.lighting.fixedMinExposure or minExposure
	proShot.FoV = math.floor(math.deg(getFovY(getCamera())) + 0.5)

	-- Backup things we'll bugger up
	local fwyc = proShot.fromWhenceYouCame
	fwyc.distanceCoeff = { ['View'] = getViewDistanceCoeff(), ['LOD'] = getLODDistanceCoeff(), ['TerrainLOD'] = getTerrainLODDistanceCoeff(), ['FoliageView'] = getFoliageViewDistanceCoeff() }
	fwyc.sun = {}
	fwyc.sun['xR'], fwyc.sun['yR'], fwyc.sun['zR'] = getRotation(proShot.sun.lightNode)
	fwyc.sun.color = { rSun, gSun, bSun }
	fwyc.noHudModeEnabled = not g_currentMission.hud.isVisible
	fwyc.colorGradingDay = g_currentMission.environment.lighting.colorGradingDay
	fwyc.visualPeriodLocked = g_currentMission.environment.visualPeriodLocked
	fwyc.currentVisualPeriod = g_currentMission.environment.currentVisualPeriod
	fwyc.DoF = g_depthOfFieldManager.currentState
	fwyc.bloom = { getBloomMagnitude(), getBloomMaskThreshold(), getBloomQuality() }
	fwyc.SSAOIntensity = getSSAOIntensity()


	-- Enable HUD if it's not visible
	if fwyc.noHudModeEnabled then
		g_currentMission.hud.isVisible = true
	end

	-- Set up our camera
	proShot.previousCamera = getCamera()
	local cam = createCamera("proShotCam", getFovY(proShot.previousCamera), getNearClip(proShot.previousCamera), getFarClip(proShot.previousCamera))
	proShot.tripod = createTransformGroup("tripod")
	link(proShot.tripod, cam)
	link(getRootNode(), proShot.tripod)
	setWorldTranslation(proShot.tripod, getWorldTranslation(proShot.previousCamera))
	setWorldRotation(proShot.tripod, getWorldRotation(proShot.previousCamera))
	setCamera(cam)
	proShot.ourCamera = cam

	proShot.invertRotY = proShot:checkInvertRotY()

	-- Set up our light
	proShot.lightLibrary = loadI3DFile(proShot.lightI3D,false,false,false)
	proShot.heldLight.lightNode = getChildAt(proShot.lightLibrary, proShot.heldLight.variation)
	proShot.lightStand = createTransformGroup("lightStand")
	link(getRootNode(), proShot.lightStand)
	proShot.placedLights = {} -- A record of placed lights
	link(proShot.tripod, proShot.heldLight.lightNode)

	-- Sun rotation calculator (beats doing quaternion math myself)
	proShot.calc1 = createTransformGroup("sunCalc1")
	proShot.calc2 = createTransformGroup("sunCalc2")
	link(proShot.calc1, proShot.calc2)
	link(proShot.tripod, proShot.calc1, 1)
	setRotation(proShot.calc1, 0, 0, 0)
	setTranslation(proShot.calc1, 0, 0, 0)
	setTranslation(proShot.calc2, 0, 0, 0)

	-- Backup environment
	fwyc.environment = createXMLFile("environmentXML", proShot.modDir .. "xml/environment.xml", "environment")
	g_currentMission.environment:saveToXMLFile(fwyc.environment, "environment")
	fwyc.snowShaderValue = g_currentMission.snowSystem.snowShaderValue
	fwyc.snowLevel = proShot:snowBusiness("getHeight")

	fwyc.sunSizeScale = getSunSizeScale()
	fwyc.atmosRefraction = getAtmosphereCornettAsymetryFactor()
	fwyc.moonSizeScale = getMoonSizeScale()

	
	-- Update season menu, to reflect current season
	proShot:seasonChange("init")
	-- Set weather to current weather... to update the dynamic menu
	proShot:weatherChange(g_weatherTypeManager.indexToName[g_currentMission.environment.weather:getWeatherTypeAtTime(g_currentMission.environment.currentMonotonicDay, g_currentMission.environment.dayTime)], true)

	if fileExists(proShot.modDir .. "xml/colorGrading/test.xml") then
		proShot.gradingTest = true
		Logging.warning("colorGrading Test mode is active: Some features won't work properly, as the colorGrading resets them. Remove the test.xml in the colorGrading directory to disable")
	end

	proShot.isSet = true
end

-- Called by EventListener when mouse event happens
function proShot:mouseEvent(posX, posY, isDown, isUp, button)
	if proShot.isActive then
		-- Update mouse button states
		if isDown then
			proShot.mouseButtonDown[button] = true
		elseif isUp then
			proShot.mouseButtonDown[button] = false
		end

		-- See if any mouse buttons are down
		local anyMouseButtonDown = false
		-- Sparse array! Run away...
		for key in pairs(proShot.mouseButtonDown) do
			if proShot.mouseButtonDown[key] then
				anyMouseButtonDown = true
			end
		end

		-- If any button is down, update the camera
		if anyMouseButtonDown then
		proShot:camMoveMouse(proShot.tripod, posX, posY, proShot.mouseButtonDown)
		end
	end
end

-- Called once during game loading
function proShot:insteadof_GamePausedDisplay_createBackground(superFunc, hudAtlasPath)
	local _, height = getNormalizedScreenValues(unpack(GamePausedDisplay.SIZE.SELF))
	proShot.overlay = Overlay.new(hudAtlasPath, 0, (1 - height) * 0.5, 1, height)
	proShot.overlay:setUVs(GuiUtils.getUVs(GamePausedDisplay.UV.BACKGROUND))
	proShot.overlay:setColor(0,0,0,0)
	return proShot.overlay
end

-- Called repeatedly while paused
function proShot:insteadof_GamePausedDisplay_draw(superFunc, dt)
	proShot.isActive = self:getVisible()
	if proShot.isActive then
		if not proShot.isSet then
			proShot:setOnPause()
		end

		-- Check camera hasn't been lost due to vehicle reload
		if proShot.ourCamera ~= getCamera() then
			if g_currentMission.controlledVehicle ~= nil and g_currentMission.controlledVehicle.getActiveCamera ~= nil then
				local currVehicleCamera = g_currentMission.controlledVehicle:getActiveCamera().cameraNode
				if currVehicleCamera ~= proShot.previousCamera then
					Logging.info("Resetting vehicle camera after vehicle reload")
					proShot.previousCamera = currVehicleCamera
				end
			end
			Logging.info("Switching back to ProShot camera, after vehicle reload")
			setCamera(proShot.ourCamera)
		end

		if proShot.captureCoolDown < 1 then
			if not g_currentMission.hud.isVisible and proShot.reEnableHUD then
				g_currentMission.hud.isVisible = true
				proShot.reEnableHUD = false
			end

			proShot:updateControlsMenu()
			proShot:updateInfoBox()
		end

		if proShot.captureCoolDown > 0 then
			if proShot.captureCoolDown == 25 then
				proShot:captureScreen()
			end
			proShot.captureCoolDown = proShot.captureCoolDown - 1
		end

		proShot:keyRepeatThrottle(true)
		proShot:inputKeyboardUpdate()

		-- Render paused text and icon
		if g_currentMission.hud.isVisible then
			local baseX, _ = g_currentMission.hud.gamePausedDisplay:getPosition()
			local posX = baseX + g_currentMission.hud.gamePausedDisplay:getWidth() * 0.5 + g_currentMission.hud.gamePausedDisplay.textOffsetX
			local textSize = g_currentMission.hud.gamePausedDisplay.textSize
			setTextBold(true)
			setTextAlignment(RenderText.ALIGN_CENTER)

			setTextColor(0, 0, 0, 0.9)
			renderText(posX + (0.05 * textSize), getTextHeight(textSize, g_currentMission.hud.gamePausedDisplay.pauseText)	- (0.05 * textSize), textSize, g_currentMission.hud.gamePausedDisplay.pauseText)

			setTextColor(unpack(GamePausedDisplay.COLOR.TEXT))
			renderText(posX, getTextHeight(textSize, g_currentMission.hud.gamePausedDisplay.pauseText), textSize, g_currentMission.hud.gamePausedDisplay.pauseText)

			renderOverlay(createImageOverlay(proShot.modDir .. "modIcon.dds"), 0, 0, 0.1/g_screenAspectRatio, 0.1);
		end

		if proShot.gradingTest and fileExists(proShot.modDir .. "xml/colorGrading/test.xml") then
			proShot:colorGradingSet("test")
		end
	end
end

-- Called repeatedly by EventListener when unpaused
function proShot:update(dt)
	if proShot.isActive then
		proShot.isActive = false

		-- Un-bugger
		InputHelpDisplay.ENTRY_COUNT_PC = 8
		local fwyc = proShot.fromWhenceYouCame
		setViewDistanceCoeff(fwyc.distanceCoeff.View)
		setLODDistanceCoeff(fwyc.distanceCoeff.LOD)
		setTerrainLODDistanceCoeff(fwyc.distanceCoeff.TerrainLOD)
		setFoliageViewDistanceCoeff(fwyc.distanceCoeff.FoliageView)
		setRotation(proShot.sun.lightNode, fwyc.sun.xR, fwyc.sun.yR, fwyc.sun.zR)
		setLightColor(proShot.sun.lightNode, unpack(fwyc.sun.color))

		proShot:colorGradingSet()

		g_currentMission.environment:loadFromXMLFile(fwyc.environment, "environment")
		g_currentMission.snowSystem.snowShaderValue = fwyc.snowShaderValue
		setSharedShaderParameter(Shader.PARAM_SHARED_SNOW, fwyc.snowShaderValue)
		proShot:snowBusiness(fwyc.snowLevel)
		g_currentMission.environment.currentVisualPeriod = fwyc.currentVisualPeriod
		g_currentMission.environment.visualPeriodLocked = fwyc.visualPeriodLocked

		setDoFparams(unpack(fwyc.DoF))
		setBloomMagnitude(fwyc.bloom[1])
		setBloomMaskThreshold(fwyc.bloom[2])
		setBloomQuality(fwyc.bloom[3])
		setSSAOIntensity(fwyc.SSAOIntensity)

		setSunSizeScale(fwyc.sunSizeScale)
		setAtmosphereCornettAsymetryFactor(fwyc.atmosRefraction)
		setMoonSizeScale(fwyc.moonSizeScale)


		if fwyc.noHudModeEnabled then
			if g_currentMission.hud.isVisible then
				g_currentMission.hud.isVisible = false
			end
		else
			if not g_currentMission.hud.isVisible then
				g_currentMission.hud.isVisible = true
			end
		end

		-- Clean up in aisle 4
		setCamera(proShot.previousCamera)
		proShot.previousCamera = 0
		proShot.captureCoolDown = 0
		proShot.isSet = false
		delete(proShot.tripod)
		delete(proShot.lightStand)
		delete(proShot.lightLibrary)

		-- Tell the game to refresh stuff I might have played with
		Lighting.updateExposureSettings(g_currentMission.environment.lighting)
		
		-- lighting:updateAtmosphere(g_currentMission.environment.dayTime / 60000)
	end
end

initMod()
addModEventListener(proShot)
